/*
 * Copyright (C) 2000 Richard Groult <rgroult@jalix.org>
 * 		 2003 OGINO Tomonori <ogino@nn.iij4u.or.jp>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "compressedimagefileiconitem.h"

#include "zipfile.h"
#include "imageviewer.h"
#include "compressedfileitem.h"

#include <qdragobject.h>
#include <qdropsite.h>
#include <qlistview.h>
#include <qstring.h>
#include <qfile.h>
#include <qpopupmenu.h>
#include <qfileinfo.h>
#include <qapplication.h>
#include <klocale.h>

#include <kprocess.h>
#include <kapplication.h>
#include <kiconloader.h>

CompressedImageFileIconItem::CompressedImageFileIconItem (ImageListView *parent,
						  CompressedFileItem *parentDir,
						  const char *archive,
						  const char *filename,
						  const char *,
						  ImageViewer * iv):
//	FileIconItem (parent, "/tmp/.qlist"+QString().setNum(getpid())+"/", filename, "tgz", iv),
     FileIconItem (parent, "/tmp/.qlist"+QString().setNum(getpid())+"/"+getFullName(new QString(archive))+"/" , filename, "tgz", iv),
   f (filename)
{
	readable = TRUE;
	this->parentDir = parentDir;
	this->archive = new QString (archive);
	size = new QString ("ukn");
	this->archive = new QString (archive);
	this->filename = new QString (filename);

	fullname="/tmp/.qlist"+QString().setNum(getpid())+"/"+getFullName(new QString(archive))+"/" + filename;
	extension = new QString (QString(filename).right(3).lower());
	type = new QString ("zip");
	setName("CompressedImageFileIconItem");
	date=new QString();
	setPixmap(BarIcon(fileInfo()->iconName(), imageList->currentIconSize));
	__isimage__=true;
}

CompressedImageFileIconItem::~CompressedImageFileIconItem ()
{
}

QString
CompressedImageFileIconItem::toolTipStr() const
{
	QString tip;
	tip.sprintf("<table><tr><td>"+i18n("<b>name</b>: %s<br><b>archive</b>: %s<br>")+"</td></tr></table>",
		(const char*)text(),
		(const char*)*archive);
	tip+=fileInfo()->getToolTipText();

	return tip;
}


bool
CompressedImageFileIconItem::suppression ()
{
	QApplication::setOverrideCursor (waitCursor); // this might take time
	ZipFile (*archive, *filename).deleteFile ();
	parentDir->removeImage (this);
	QApplication::restoreOverrideCursor ();       // restore original cursor

	return true;
}

QString
CompressedImageFileIconItem::fullName ()
{
	return fullname;
}

QString
CompressedImageFileIconItem::text () const
{
	return text (0);
}


QString
CompressedImageFileIconItem::text (int column) const
{
	
	if (column == 0)
	{
		QString s(f.name ());
		int pos = s.findRev ("/");
		return QString(s.right (s.length () - pos - 1));
	}
	else if (column == 1)
	{
		return (*extension);
	}
	else if (column == 2)
	{
		return (*size+"  ");
	}
	else
		return (*type);
}

