/*
 * Copyright (C) 2000 Richard Groult <rgroult@jalix.org>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef __FILEICONITEM_H__
#define __FILEICONITEM_H__

#include "imagelistview.h"

//#include <kfileiconview.h>

#include <qtooltip.h>

class ImageViewer;

class QIconView;
class QPixmap;
class QFileInfo;
class QToolTip;

class FileIconItem : public KFileIconViewItem
{
public:
	FileIconItem(ImageListView *parent, const char* path,
					const char* filename,
					const char* icon,
					ImageViewer *iv);
	virtual ~FileIconItem();

	virtual void setPixmap ( const QPixmap & icon, bool haspreview=false );
	bool hasPreview ();
	void setHasPreview (bool preview);

	FileIconItem* nextItem ();
	FileIconItem* prevItem ();

	virtual void setName(QString n);
	virtual QString name();
	
	virtual void setType(QString type);

	virtual QString fullName();

	QString mimetype() const;
	bool isImage() const;
	bool isMovable() const;

	virtual bool suppression(bool);
	virtual bool suppression();

	virtual bool moveToTrash();
	virtual bool shred();	 

	virtual QString text(int i=0) const;

	virtual QString toolTipStr() const;

	virtual void setWallpaper();

	virtual void setKey ( const QString & k );
	void setSelected (bool s);

protected:
	QString getFileName(QString *fullName);
	QString getFileExt(QString *fullName);
	QString getFullName(QString *fullName);
	QString getFullPath(QString *fullName);

	QString getFileName(QString fullName);
	QString getFileExt(QString fullName);
	QString getFullName(QString fullName);
	QString getFullPath(QString fullName);

	QString *size;
	QString *extension;
	QString *type;
	QString *date;
	QString *description;

	QFileInfo *info;
	QString myName;
	bool haspreview;
	
	ImageViewer *iv;
	
	bool __isimage__, __ismovable__;
	
	ImageListView *imageList;

};
#endif
